/*
 * This file is generated by jOOQ.
 */
package jooq.model.tables.records;


import java.time.LocalDateTime;

import jooq.model.tables.Collision;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record4;
import org.jooq.Row4;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class CollisionRecord extends UpdatableRecordImpl<CollisionRecord> implements Record4<Integer, Integer, LocalDateTime, Long> {

    private static final long serialVersionUID = 1L;

    /**
     * Setter for <code>public.collision.plane_id</code>.
     */
    public void setPlaneId(Integer value) {
        set(0, value);
    }

    /**
     * Getter for <code>public.collision.plane_id</code>.
     */
    public Integer getPlaneId() {
        return (Integer) get(0);
    }

    /**
     * Setter for <code>public.collision.other_plane_id</code>.
     */
    public void setOtherPlaneId(Integer value) {
        set(1, value);
    }

    /**
     * Getter for <code>public.collision.other_plane_id</code>.
     */
    public Integer getOtherPlaneId() {
        return (Integer) get(1);
    }

    /**
     * Setter for <code>public.collision.time</code>.
     */
    public void setTime(LocalDateTime value) {
        set(2, value);
    }

    /**
     * Getter for <code>public.collision.time</code>.
     */
    public LocalDateTime getTime() {
        return (LocalDateTime) get(2);
    }

    /**
     * Setter for <code>public.collision.id</code>.
     */
    public void setId(Long value) {
        set(3, value);
    }

    /**
     * Getter for <code>public.collision.id</code>.
     */
    public Long getId() {
        return (Long) get(3);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    @Override
    public Record1<Long> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record4 type implementation
    // -------------------------------------------------------------------------

    @Override
    public Row4<Integer, Integer, LocalDateTime, Long> fieldsRow() {
        return (Row4) super.fieldsRow();
    }

    @Override
    public Row4<Integer, Integer, LocalDateTime, Long> valuesRow() {
        return (Row4) super.valuesRow();
    }

    @Override
    public Field<Integer> field1() {
        return Collision.COLLISION.PLANE_ID;
    }

    @Override
    public Field<Integer> field2() {
        return Collision.COLLISION.OTHER_PLANE_ID;
    }

    @Override
    public Field<LocalDateTime> field3() {
        return Collision.COLLISION.TIME;
    }

    @Override
    public Field<Long> field4() {
        return Collision.COLLISION.ID;
    }

    @Override
    public Integer component1() {
        return getPlaneId();
    }

    @Override
    public Integer component2() {
        return getOtherPlaneId();
    }

    @Override
    public LocalDateTime component3() {
        return getTime();
    }

    @Override
    public Long component4() {
        return getId();
    }

    @Override
    public Integer value1() {
        return getPlaneId();
    }

    @Override
    public Integer value2() {
        return getOtherPlaneId();
    }

    @Override
    public LocalDateTime value3() {
        return getTime();
    }

    @Override
    public Long value4() {
        return getId();
    }

    @Override
    public CollisionRecord value1(Integer value) {
        setPlaneId(value);
        return this;
    }

    @Override
    public CollisionRecord value2(Integer value) {
        setOtherPlaneId(value);
        return this;
    }

    @Override
    public CollisionRecord value3(LocalDateTime value) {
        setTime(value);
        return this;
    }

    @Override
    public CollisionRecord value4(Long value) {
        setId(value);
        return this;
    }

    @Override
    public CollisionRecord values(Integer value1, Integer value2, LocalDateTime value3, Long value4) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached CollisionRecord
     */
    public CollisionRecord() {
        super(Collision.COLLISION);
    }

    /**
     * Create a detached, initialised CollisionRecord
     */
    public CollisionRecord(Integer planeId, Integer otherPlaneId, LocalDateTime time, Long id) {
        super(Collision.COLLISION);

        setPlaneId(planeId);
        setOtherPlaneId(otherPlaneId);
        setTime(time);
        setId(id);
        resetChangedOnNotNull();
    }
}
